#include <stdio.h>

#include <Mrm/MrmPublic.h>
#include <Xm/Xm.h>
#include <Xm/PushB.h>
#include <Xm/Frame.h>

void add_usr(Widget w, XtPointer app_data, XtPointer widget_data);
void delete_usr(Widget w, XtPointer app_data, XtPointer widget_data);
void invite_usrs(Widget w, XtPointer app_data, XtPointer widget_data);
void add_cancel(Widget w, XtPointer app_data, XtPointer widget_data);

static MrmRegisterArg cb_list[] = 
{
  { "add_usr",     (XtPointer)add_usr     },
  { "delete_usr",  (XtPointer)delete_usr  },
  { "invite_usrs", (XtPointer)invite_usrs },
  { "add_cancel",  (XtPointer)add_cancel  }
};

String fallbacks[] = { "*fontList: -*-helvetica-bold-r-normal--14-*-*-*-*-*-*-*=charset", NULL };

main(int argc, char **argv)
{
  Widget         app_shell, top_level;     
  XtAppContext   app;     
  static String  file_names[] = { "add.uid"};     
  MrmHierarchy   hierarchy_id;     
  MrmType        top_level_class;

  app_shell = XtVaAppInitialize(&app, "Example", (XrmOptionDescList) NULL, 0, 
			      (Cardinal *) &argc, argv, 
			      (ArgList) fallbacks, NULL);
  MrmInitialize();     
  switch (MrmOpenHierarchyPerDisplay(XtDisplay(app_shell), 
				     (MrmCount) XtNumber(file_names), 
				     file_names,              
				     (MrmOsOpenParamPtr *) NULL, 
				     &hierarchy_id)) 
    {     
    case MrmSUCCESS:         
      if (MrmRegisterNames(cb_list, (MrmCount)XtNumber(cb_list)) != MrmSUCCESS)
	fprintf(stderr, "Unable to register callbacks\n");

      if (MrmFetchWidget(hierarchy_id, "simpleWindow",
			 app_shell, &top_level, &top_level_class)
	  != MrmSUCCESS) 
	{
	  fprintf(stderr, "Unable to fetch top-level widget.\n");
        }      

      XtManageChild(top_level);
      XtRealizeWidget(app_shell);

      XtAppMainLoop(app);
      
      if (MrmCloseHierarchy(hierarchy_id) == MrmSUCCESS) 
	{             
	  exit(0);         
	} 
      else 
	{             
	  fprintf(stderr, "Unable to close UID hierarchy.\n");             
	  exit(1);         
	}     
    case MrmNOT_FOUND:         
      fprintf(stderr, "Unable to open UID files.\n");         
      exit (1);     
    default:
      fprintf(stderr, "Unable to open UID hierarchy.\n");
      exit (1);
    }  
}


void add_usr(Widget w, XtPointer app_data, XtPointer widget_data)
{
  printf("User added\n");
}

void delete_usr(Widget w, XtPointer app_data, XtPointer widget_data)
{
  printf("User deleted\n");
}

void invite_usrs(Widget w, XtPointer app_data, XtPointer widget_data)
{
  printf("Users invited\n");
}

void add_cancel(Widget w, XtPointer app_data, XtPointer widget_data)
{
  printf("Cancel\n");
}




